EXE = $(addsuffix .exe, $(basename $(wildcard *.cpp)))

CPPC = g++
CPP_FLAGS = -Ofast -march=native -std=c++17# -pedantic -Wall -Wextra
OPENMP_FLAGS =

EX_LIB_PATH = ../../extern_libraries

libMoM_INC_PATH = ../libMoM/inc/

EIGEN_PATH = $(EX_LIB_PATH)/

DCO_INC_DIR = $(EX_LIB_PATH)/dco/include/
DCO_LIB_DIR = $(EX_LIB_PATH)/dco/lib/
DCO_LIB = dcoc
DCO_FLAGS = -DDCO_DISABLE_AUTO_WARNING

COLPACK_PATH = $(EX_LIB_PATH)/ColPack/inc/
COLPACKHEADER_PATH = $(EX_LIB_PATH)/ColPack/src/Utilies/

COLPACK_ROOT = $(EX_LIB_PATH)/ColPack

COLPACK_INCLUDES = -I./
COLPACK_INCLUDES += -I${COLPACK_ROOT}/inc
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/GeneralGraphColoring
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/BipartiteGraphBicoloring
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/BipartiteGraphPartialColoring
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/Utilities
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/Recovery
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/SMPGC
COLPACK_INCLUDES += -I${COLPACK_ROOT}/src/PartialD2SMPGC

COLPACK_LIB = -ldl ${COLPACK_ROOT}/build/cmake/mywork/libColPack.so
COLPACK_LIB += -ldl ${COLPACK_ROOT}/build/cmake/mywork/libColPack.so.0
 
all: $(EXE)


%.exe: %.cpp
	$(CPPC) $(CPP_FLAGS) $(OPENMP_FLAGS) -I$(libMoM_INC_PATH) -I$(EIGEN_PATH) -I$(DCO_INC_DIR) -L$(DCO_LIB_DIR) $(DCO_FLAGS) $(COLPACK_INCLUDES) $< -o $@ -l$(DCO_LIB) $(COLPACK_LIB)

doc:
	cd doc && $(MAKE)

test: dense_example.exe sparse_example.exe
	./dense_example.exe
	./sparse_example.exe

example: example1.exe example2.exe example3.exe
	./example1.exe
	./example2.exe
	./example3.exe

clean:
	cd doc && $(MAKE) clean
	rm -f $(EXE)
	rm -f *.csv

.PHONY: clean doc all